//                              --- OpenGL 1.5 ---

#ifndef GL_VERSION_1_5
#define GL_VERSION_1_5 1
#define __GENERATE_GL_15__

extern bool GLEH_OPENGL_1_5; /**< @brief set if OpenGL 1.5 is supported */

#define GL_BUFFER_SIZE                                              0x8764
#define GL_BUFFER_USAGE                                             0x8765
#define GL_QUERY_COUNTER_BITS                                       0x8864
#define GL_CURRENT_QUERY                                            0x8865
#define GL_QUERY_RESULT                                             0x8866
#define GL_QUERY_RESULT_AVAILABLE                                   0x8867
#define GL_ARRAY_BUFFER                                             0x8892
#define GL_ELEMENT_ARRAY_BUFFER                                     0x8893
#define GL_ARRAY_BUFFER_BINDING                                     0x8894
#define GL_ELEMENT_ARRAY_BUFFER_BINDING                             0x8895
//#define GL_VERTEX_ARRAY_BUFFER_BINDING                              0x8896 // deprecated
//#define GL_NORMAL_ARRAY_BUFFER_BINDING                              0x8897 // deprecated
//#define GL_COLOR_ARRAY_BUFFER_BINDING                               0x8898 // deprecated
//#define GL_INDEX_ARRAY_BUFFER_BINDING                               0x8899 // deprecated
//#define GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING                       0x889A // deprecated
//#define GL_EDGE_FLAG_ARRAY_BUFFER_BINDING                           0x889B // deprecated
//#define GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING                     0x889C // deprecated
//#define GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING                      0x889D // deprecated
//#define GL_WEIGHT_ARRAY_BUFFER_BINDING                              0x889E // deprecated
#define GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING                       0x889F
#define GL_READ_ONLY                                                0x88B8
#define GL_WRITE_ONLY                                               0x88B9
#define GL_READ_WRITE                                               0x88BA
#define GL_BUFFER_ACCESS                                            0x88BB
#define GL_BUFFER_MAPPED                                            0x88BC
#define GL_BUFFER_MAP_POINTER                                       0x88BD
#define GL_STREAM_DRAW                                              0x88E0
#define GL_STREAM_READ                                              0x88E1
#define GL_STREAM_COPY                                              0x88E2
#define GL_STATIC_DRAW                                              0x88E4
#define GL_STATIC_READ                                              0x88E5
#define GL_STATIC_COPY                                              0x88E6
#define GL_DYNAMIC_DRAW                                             0x88E8
#define GL_DYNAMIC_READ                                             0x88E9
#define GL_DYNAMIC_COPY                                             0x88EA
#define GL_SAMPLES_PASSED                                           0x8914
//#define GL_FOG_COORD_SRC                                            GL_FOG_COORDINATE_SOURCE // deprecated
//#define GL_FOG_COORD                                                GL_FOG_COORDINATE // deprecated
//#define GL_CURRENT_FOG_COORD                                        GL_CURRENT_FOG_COORDINATE // deprecated
//#define GL_FOG_COORD_ARRAY_TYPE                                     GL_FOG_COORDINATE_ARRAY_TYPE // deprecated
//#define GL_FOG_COORD_ARRAY_STRIDE                                   GL_FOG_COORDINATE_ARRAY_STRIDE // deprecated
//#define GL_FOG_COORD_ARRAY_POINTER                                  GL_FOG_COORDINATE_ARRAY_POINTER // deprecated
//#define GL_FOG_COORD_ARRAY                                          GL_FOG_COORDINATE_ARRAY // deprecated
//#define GL_FOG_COORD_ARRAY_BUFFER_BINDING                           GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING // deprecated
//#define GL_SRC0_RGB                                                 GL_SOURCE0_RGB // deprecated
//#define GL_SRC1_RGB                                                 GL_SOURCE1_RGB // deprecated
//#define GL_SRC2_RGB                                                 GL_SOURCE2_RGB // deprecated
//#define GL_SRC0_ALPHA                                               GL_SOURCE0_ALPHA // deprecated
//#define GL_SRC1_ALPHA                                               GL_SOURCE1_ALPHA // deprecated
//#define GL_SRC2_ALPHA                                               GL_SOURCE2_ALPHA // deprecated

/**
 *  @brief generate query object names
 *  @param[in] n Specifies the number of query object names to be generated.
 *  @param[out] ids Specifies an array in which the generated query object names are stored.
 */
extern void (GLApi *GLFuncPtrName(glGenQueries))(GLsizei n, GLuint *ids);

/**
 *  @brief delete named query objects
 *  @param[in] n Specifies the number of query objects to be deleted.
 *  @param[in] ids Specifies an array of query objects to be deleted.
 */
extern void (GLApi *GLFuncPtrName(glDeleteQueries))(GLsizei n, const GLuint *ids);

/**
 *  @brief determine if a name corresponds to a query object
 *  @param[in] id Specifies a value that may be the name of a query object.
 */
extern GLboolean (GLApi *GLFuncPtrName(glIsQuery))(GLuint id);

/**
 *  @brief delimit the boundaries of a query object
 *  @param[in] target Specifies the target type of query object established between glBeginQuery and
 *      the subsequent glEndQuery. The symbolic constant must be one of GL_SAMPLES_PASSED,
 *      GL_ANY_SAMPLES_PASSED, GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, or GL_TIME_ELAPSED.
 *  @param[in] id Specifies the name of a query object.
 */
extern void (GLApi *GLFuncPtrName(glBeginQuery))(GLenum target, GLuint id);

/**
 *  @brief delimit the boundaries of a query object
 *  @param[in] target Specifies the target type of query object to be concluded. The symbolic
 *      constant must be one of GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_PRIMITIVES_GENERATED,
 *      GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, or GL_TIME_ELAPSED.
 */
extern void (GLApi *GLFuncPtrName(glEndQuery))(GLenum target);

/**
 *  @brief return parameters of a query object target
 *  @param[in] target Specifies a query object target. Must be GL_SAMPLES_PASSED,
 *      GL_ANY_SAMPLES_PASSED, GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN,
 *      GL_TIME_ELAPSED, or GL_TIMESTAMP.
 *  @param[in] pname Specifies the symbolic name of a query object target parameter. Accepted values
 *      are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
 *  @param[out] params Returns the requested data.
 */
extern void (GLApi *GLFuncPtrName(glGetQueryiv))(GLenum target, GLenum pname, int *params);

/**
 *  @brief return parameters of a query object
 *  @param[in] id Specifies the name of a query object.
 *  @param[in] pname Specifies the symbolic name of a query object parameter. Accepted values are
 *      GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
 *  @param[out] params Returns the requested data.
 */
extern void (GLApi *GLFuncPtrName(glGetQueryObjectiv))(GLuint id, GLenum pname, int *params);

/**
 *  @brief return parameters of a query object
 *  @param[in] id Specifies the name of a query object.
 *  @param[in] pname Specifies the symbolic name of a query object parameter. Accepted values are
 *      GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
 *  @param[out] params Returns the requested data.
 */
extern void (GLApi *GLFuncPtrName(glGetQueryObjectuiv))(GLuint id, GLenum pname, GLuint *params);

/**
 *  @brief bind a named buffer object
 *  @param[in] target Specifies the target to which the buffer object is bound. The symbolic
 *      constant must be GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER,
 *      GL_DRAW_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER,
 *      GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] buffer Specifies the name of a buffer object.
 */
extern void (GLApi *GLFuncPtrName(glBindBuffer))(GLenum target, GLuint buffer);

/**
 *  @brief delete named buffer objects
 *  @param[in] n Specifies the number of buffer objects to be deleted.
 *  @param[in] buffers Specifies an array of buffer objects to be deleted.
 */
extern void (GLApi *GLFuncPtrName(glDeleteBuffers))(GLsizei n, const GLuint *buffers);

/**
 *  @brief generate buffer object names
 *  @param[in] n Specifies the number of buffer object names to be generated.
 *  @param[out] buffers Specifies an array in which the generated buffer object names are stored.
 */
extern void (GLApi *GLFuncPtrName(glGenBuffers))(GLsizei n, GLuint *buffers);

/**
 *  @brief determine if a name corresponds to a buffer object
 *  @param[in] buffer Specifies a value that may be the name of a buffer object.
 */
extern GLboolean (GLApi *GLFuncPtrName(glIsBuffer))(GLuint buffer);

/**
 *  @brief creates and initializes a buffer object's data store
 *  @param[in] target Specifies the target buffer object. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] size Specifies the size in bytes of the buffer object's new data store.
 *  @param[in] data Specifies a pointer to data that will be copied into the data store for
 *      initialization, or NULL if no data is to be copied.
 *  @param[in] usage Specifies the expected usage pattern of the data store. The symbolic constant
 *      must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ,
 *      GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
 */
extern void (GLApi *GLFuncPtrName(glBufferData))(GLenum target, GLsizeiptr size, const void *data, GLenum usage);

/**
 *  @brief updates a subset of a buffer object's data store
 *  @param[in] target Specifies the target buffer object. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] offset Specifies the offset into the buffer object's data store where data
 *      replacement will begin, measured in bytes.
 *  @param[in] size Specifies the size in bytes of the data store region being replaced.
 *  @param[in] data Specifies a pointer to the new data that will be copied into the data store.
 */
extern void (GLApi *GLFuncPtrName(glBufferSubData))(GLenum target, GLintptr offset, GLsizeiptr size, const void *data);

/**
 *  @brief returns a subset of a buffer object's data store
 *  @param[in] target Specifies the target buffer object. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] offset Specifies the offset into the buffer object's data store from which data will
 *      be returned, measured in bytes.
 *  @param[in] size Specifies the size in bytes of the data store region being returned.
 *  @param[out] data Specifies a pointer to the location where buffer object data is returned.
 */
extern void (GLApi *GLFuncPtrName(glGetBufferSubData))(GLenum target, GLintptr offset, GLsizeiptr size, void *data);

/**
 *  @brief map a buffer object's data store
 *  @param[in] target Specifies the target buffer object being mapped. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER or GL_UNIFORM_BUFFER.
 *  @param[in] access Specifies the access policy, indicating whether it will be possible to read
 *      from, write to, or both read from and write to the buffer object's mapped data store. The
 *      symbolic constant must be GL_READ_ONLY, GL_WRITE_ONLY, or GL_READ_WRITE.
 */
extern void* (GLApi *GLFuncPtrName(glMapBuffer))(GLenum target, GLenum access);

/**
 *  @brief map a buffer object's data store
 *  @param[in] target Specifies the target buffer object being unmapped. The symbolic constant must
 *      be GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER or GL_UNIFORM_BUFFER.
 */
extern GLboolean (GLApi *GLFuncPtrName(glUnmapBuffer))(GLenum target);

/**
 *  @brief return parameters of a buffer object
 *  @param[in] target Specifies the target buffer object. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] value Specifies the symbolic name of a buffer object parameter. Accepted values are
 *      GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
 *  @param[out] data Returns the requested parameter.
 */
extern void (GLApi *GLFuncPtrName(glGetBufferParameteriv))(GLenum target, GLenum value, int *data);

/**
 *  @brief return the pointer to a mapped buffer object's data store
 *  @param[in] target Specifies the target buffer object. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] pname Specifies the pointer to be returned. The symbolic constant must be GL_BUFFER_MAP_POINTER.
 *  @param[out] params Returns the pointer value specified by pname.
 */
extern void (GLApi *GLFuncPtrName(glGetBufferPointerv))(GLenum target, GLenum pname, void **params);

inline GLboolean glIsQuery_glachwrap(GLuint id, const char *p_s_filename, int n_line) { GLboolean result = GLFuncPtrName(glIsQuery)(id); GL_AUTOCHECK_BLOCK("glIsQuery", p_s_filename, n_line); return result; }
inline GLboolean glIsBuffer_glachwrap(GLuint buffer, const char *p_s_filename, int n_line) { GLboolean result = GLFuncPtrName(glIsBuffer)(buffer); GL_AUTOCHECK_BLOCK("glIsBuffer", p_s_filename, n_line); return result; }
inline void *glMapBuffer_glachwrap(GLenum target, GLenum access, const char *p_s_filename, int n_line) { void *result = GLFuncPtrName(glMapBuffer)(target,access); GL_AUTOCHECK_BLOCK("glMapBuffer", p_s_filename, n_line); return result; }
inline GLboolean glUnmapBuffer_glachwrap(GLenum target, const char *p_s_filename, int n_line) { GLboolean result = GLFuncPtrName(glUnmapBuffer)(target); GL_AUTOCHECK_BLOCK("glUnmapBuffer", p_s_filename, n_line); return result; }

/**
 *  @def glGenQueries
 *  @brief generate query object names
 *  @param[in] n Specifies the number of query object names to be generated.
 *  @param[out] ids Specifies an array in which the generated query object names are stored.
 */
#define glGenQueries(n,ids) do { GLFuncPtrName(glGenQueries)(n, ids); GL_AUTOCHECK_BLOCK("glGenQueries", __FILE__, __LINE__); } while(0)

/**
 *  @def glDeleteQueries
 *  @brief delete named query objects
 *  @param[in] n Specifies the number of query objects to be deleted.
 *  @param[in] ids Specifies an array of query objects to be deleted.
 */
#define glDeleteQueries(n,ids) do { GLFuncPtrName(glDeleteQueries)(n, ids); GL_AUTOCHECK_BLOCK("glDeleteQueries", __FILE__, __LINE__); } while(0)

/**
 *  @def glIsQuery
 *  @brief determine if a name corresponds to a query object
 *  @param[in] id Specifies a value that may be the name of a query object.
 */
#define glIsQuery(id) GLAutoCheckFuncPtrName(glIsQuery)(id GLAutoCheckExtraParams)

/**
 *  @def glBeginQuery
 *  @brief delimit the boundaries of a query object
 *  @param[in] target Specifies the target type of query object established between glBeginQuery and
 *      the subsequent glEndQuery. The symbolic constant must be one of GL_SAMPLES_PASSED,
 *      GL_ANY_SAMPLES_PASSED, GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, or GL_TIME_ELAPSED.
 *  @param[in] id Specifies the name of a query object.
 */
#define glBeginQuery(target,id) do { GLFuncPtrName(glBeginQuery)(target, id); GL_AUTOCHECK_BLOCK("glBeginQuery", __FILE__, __LINE__); } while(0)

/**
 *  @def glEndQuery
 *  @brief delimit the boundaries of a query object
 *  @param[in] target Specifies the target type of query object to be concluded. The symbolic
 *      constant must be one of GL_SAMPLES_PASSED, GL_ANY_SAMPLES_PASSED, GL_PRIMITIVES_GENERATED,
 *      GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN, or GL_TIME_ELAPSED.
 */
#define glEndQuery(target) do { GLFuncPtrName(glEndQuery)(target); GL_AUTOCHECK_BLOCK("glEndQuery", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetQueryiv
 *  @brief return parameters of a query object target
 *  @param[in] target Specifies a query object target. Must be GL_SAMPLES_PASSED,
 *      GL_ANY_SAMPLES_PASSED, GL_PRIMITIVES_GENERATED, GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN,
 *      GL_TIME_ELAPSED, or GL_TIMESTAMP.
 *  @param[in] pname Specifies the symbolic name of a query object target parameter. Accepted values
 *      are GL_CURRENT_QUERY or GL_QUERY_COUNTER_BITS.
 *  @param[out] params Returns the requested data.
 */
#define glGetQueryiv(target,pname,params) do { GLFuncPtrName(glGetQueryiv)(target, pname, params); GL_AUTOCHECK_BLOCK("glGetQueryiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetQueryObjectiv
 *  @brief return parameters of a query object
 *  @param[in] id Specifies the name of a query object.
 *  @param[in] pname Specifies the symbolic name of a query object parameter. Accepted values are
 *      GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
 *  @param[out] params Returns the requested data.
 */
#define glGetQueryObjectiv(id,pname,params) do { GLFuncPtrName(glGetQueryObjectiv)(id, pname, params); GL_AUTOCHECK_BLOCK("glGetQueryObjectiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetQueryObjectuiv
 *  @brief return parameters of a query object
 *  @param[in] id Specifies the name of a query object.
 *  @param[in] pname Specifies the symbolic name of a query object parameter. Accepted values are
 *      GL_QUERY_RESULT or GL_QUERY_RESULT_AVAILABLE.
 *  @param[out] params Returns the requested data.
 */
#define glGetQueryObjectuiv(id,pname,params) do { GLFuncPtrName(glGetQueryObjectuiv)(id, pname, params); GL_AUTOCHECK_BLOCK("glGetQueryObjectuiv", __FILE__, __LINE__); } while(0)

/**
 *  @def glBindBuffer
 *  @brief bind a named buffer object
 *  @param[in] target Specifies the target to which the buffer object is bound. The symbolic
 *      constant must be GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER,
 *      GL_DRAW_INDIRECT_BUFFER, GL_ELEMENT_ARRAY_BUFFER, GL_PIXEL_PACK_BUFFER,
 *      GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER, GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] buffer Specifies the name of a buffer object.
 */
#define glBindBuffer(target,buffer) do { GLFuncPtrName(glBindBuffer)(target, buffer); GL_AUTOCHECK_BLOCK("glBindBuffer", __FILE__, __LINE__); } while(0)

/**
 *  @def glDeleteBuffers
 *  @brief delete named buffer objects
 *  @param[in] n Specifies the number of buffer objects to be deleted.
 *  @param[in] buffers Specifies an array of buffer objects to be deleted.
 */
#define glDeleteBuffers(n,buffers) do { GLFuncPtrName(glDeleteBuffers)(n, buffers); GL_AUTOCHECK_BLOCK("glDeleteBuffers", __FILE__, __LINE__); } while(0)

/**
 *  @def glGenBuffers
 *  @brief generate buffer object names
 *  @param[in] n Specifies the number of buffer object names to be generated.
 *  @param[out] buffers Specifies an array in which the generated buffer object names are stored.
 */
#define glGenBuffers(n,buffers) do { GLFuncPtrName(glGenBuffers)(n, buffers); GL_AUTOCHECK_BLOCK("glGenBuffers", __FILE__, __LINE__); } while(0)

/**
 *  @def glIsBuffer
 *  @brief determine if a name corresponds to a buffer object
 *  @param[in] buffer Specifies a value that may be the name of a buffer object.
 */
#define glIsBuffer(buffer) GLAutoCheckFuncPtrName(glIsBuffer)(buffer GLAutoCheckExtraParams)

/**
 *  @def glBufferData
 *  @brief creates and initializes a buffer object's data store
 *  @param[in] target Specifies the target buffer object. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] size Specifies the size in bytes of the buffer object's new data store.
 *  @param[in] data Specifies a pointer to data that will be copied into the data store for
 *      initialization, or NULL if no data is to be copied.
 *  @param[in] usage Specifies the expected usage pattern of the data store. The symbolic constant
 *      must be GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ,
 *      GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.
 */
#define glBufferData(target,size,data,usage) do { GLFuncPtrName(glBufferData)(target, size, data, usage); GL_AUTOCHECK_BLOCK("glBufferData", __FILE__, __LINE__); } while(0)

/**
 *  @def glBufferSubData
 *  @brief updates a subset of a buffer object's data store
 *  @param[in] target Specifies the target buffer object. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] offset Specifies the offset into the buffer object's data store where data
 *      replacement will begin, measured in bytes.
 *  @param[in] size Specifies the size in bytes of the data store region being replaced.
 *  @param[in] data Specifies a pointer to the new data that will be copied into the data store.
 */
#define glBufferSubData(target,offset,size,data) do { GLFuncPtrName(glBufferSubData)(target, offset, size, data); GL_AUTOCHECK_BLOCK("glBufferSubData", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetBufferSubData
 *  @brief returns a subset of a buffer object's data store
 *  @param[in] target Specifies the target buffer object. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] offset Specifies the offset into the buffer object's data store from which data will
 *      be returned, measured in bytes.
 *  @param[in] size Specifies the size in bytes of the data store region being returned.
 *  @param[out] data Specifies a pointer to the location where buffer object data is returned.
 */
#define glGetBufferSubData(target,offset,size,data) do { GLFuncPtrName(glGetBufferSubData)(target, offset, size, data); GL_AUTOCHECK_BLOCK("glGetBufferSubData", __FILE__, __LINE__); } while(0)

/**
 *  @def glMapBuffer
 *  @brief map a buffer object's data store
 *  @param[in] target Specifies the target buffer object being mapped. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER or GL_UNIFORM_BUFFER.
 *  @param[in] access Specifies the access policy, indicating whether it will be possible to read
 *      from, write to, or both read from and write to the buffer object's mapped data store. The
 *      symbolic constant must be GL_READ_ONLY, GL_WRITE_ONLY, or GL_READ_WRITE.
 */
#define glMapBuffer(target,access) GLAutoCheckFuncPtrName(glMapBuffer)(target, access GLAutoCheckExtraParams)

/**
 *  @def glUnmapBuffer
 *  @brief map a buffer object's data store
 *  @param[in] target Specifies the target buffer object being unmapped. The symbolic constant must
 *      be GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER or GL_UNIFORM_BUFFER.
 */
#define glUnmapBuffer(target) GLAutoCheckFuncPtrName(glUnmapBuffer)(target GLAutoCheckExtraParams)

/**
 *  @def glGetBufferParameteriv
 *  @brief return parameters of a buffer object
 *  @param[in] target Specifies the target buffer object. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] value Specifies the symbolic name of a buffer object parameter. Accepted values are
 *      GL_BUFFER_ACCESS, GL_BUFFER_MAPPED, GL_BUFFER_SIZE, or GL_BUFFER_USAGE.
 *  @param[out] data Returns the requested parameter.
 */
#define glGetBufferParameteriv(target,value,data) do { GLFuncPtrName(glGetBufferParameteriv)(target, value, data); GL_AUTOCHECK_BLOCK("glGetBufferParameteriv", __FILE__, __LINE__); } while(0)

/**
 *  @def glGetBufferPointerv
 *  @brief return the pointer to a mapped buffer object's data store
 *  @param[in] target Specifies the target buffer object. The symbolic constant must be
 *      GL_ARRAY_BUFFER, GL_COPY_READ_BUFFER, GL_COPY_WRITE_BUFFER, GL_ELEMENT_ARRAY_BUFFER,
 *      GL_PIXEL_PACK_BUFFER, GL_PIXEL_UNPACK_BUFFER, GL_TEXTURE_BUFFER,
 *      GL_TRANSFORM_FEEDBACK_BUFFER, or GL_UNIFORM_BUFFER.
 *  @param[in] pname Specifies the pointer to be returned. The symbolic constant must be GL_BUFFER_MAP_POINTER.
 *  @param[out] params Returns the pointer value specified by pname.
 */
#define glGetBufferPointerv(target,pname,params) do { GLFuncPtrName(glGetBufferPointerv)(target, pname, params); GL_AUTOCHECK_BLOCK("glGetBufferPointerv", __FILE__, __LINE__); } while(0)

#endif // GL_VERSION_1_5

//                              --- ~OpenGL 1.5 ---

