
    /**
     *  @brief gets GL_ARB_depth_buffer_float (part of OpenGL 3.0 core) function pointers, and sets GLEH_ARB_depth_buffer_float
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBDepthBufferFloatFuncPointers();

    /**
     *  @brief gets GL_ARB_framebuffer_object (part of OpenGL 3.0 core) function pointers, and sets GLEH_ARB_framebuffer_object
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBFramebufferObjectFuncPointers();

    /**
     *  @brief gets GL_ARB_framebuffer_sRGB (part of OpenGL 3.0 core) function pointers, and sets GLEH_ARB_framebuffer_sRGB
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBFramebufferSRGBFuncPointers();

    /**
     *  @brief gets GL_ARB_half_float_vertex (part of OpenGL 3.0 core) function pointers, and sets GLEH_ARB_half_float_vertex
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBHalfFloatVertexFuncPointers();

    /**
     *  @brief gets GL_ARB_map_buffer_range (part of OpenGL 3.0 core) function pointers, and sets GLEH_ARB_map_buffer_range
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBMapBufferRangeFuncPointers();

    /**
     *  @brief gets GL_ARB_texture_compression_rgtc (part of OpenGL 3.0 core) function pointers, and sets GLEH_ARB_texture_compression_rgtc
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBTextureCompressionRGtcFuncPointers();

    /**
     *  @brief gets GL_ARB_texture_rg (part of OpenGL 3.0 core) function pointers, and sets GLEH_ARB_texture_rg
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBTextureRGFuncPointers();

    /**
     *  @brief gets GL_ARB_vertex_array_object (part of OpenGL 3.0 core) function pointers, and sets GLEH_ARB_vertex_array_object
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBVertexArrayObjectFuncPointers();

    /**
     *  @brief gets GL_ARB_uniform_buffer_object (part of OpenGL 3.1 core) function pointers, and sets GLEH_ARB_uniform_buffer_object
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBUniformBufferObjectFuncPointers();

    /**
     *  @brief gets GL_ARB_draw_instanced (part of OpenGL 3.1 core) function pointers, and sets GLEH_ARB_draw_instanced
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBDrawInstancedFuncPointers();

    /**
     *  @brief gets GL_ARB_copy_buffer (part of OpenGL 3.1 core) function pointers, and sets GLEH_ARB_copy_buffer
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBCopyBufferFuncPointers();

    /**
     *  @brief gets GL_ARB_depth_clamp (part of OpenGL 3.2 core) function pointers, and sets GLEH_ARB_depth_clamp
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBDepthClampFuncPointers();

    /**
     *  @brief gets GL_ARB_draw_elements_base_vertex (part of OpenGL 3.2 core) function pointers, and sets GLEH_ARB_draw_elements_base_vertex
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBDrawElementsBaseVertexFuncPointers();

    /**
     *  @brief gets GL_ARB_fragment_coord_conventions (part of OpenGL 3.2 core) function pointers, and sets GLEH_ARB_fragment_coord_conventions
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBFragmentCoordConventionsFuncPointers();

    /**
     *  @brief gets GL_ARB_provoking_vertex (part of OpenGL 3.2 core) function pointers, and sets GLEH_ARB_provoking_vertex
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBProvokingVertexFuncPointers();

    /**
     *  @brief gets GL_ARB_seamless_cube_map (part of OpenGL 3.2 core) function pointers, and sets GLEH_ARB_seamless_cube_map
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBSeamlessCubeMapFuncPointers();

    /**
     *  @brief gets GL_ARB_sync (part of OpenGL 3.2 core) function pointers, and sets GLEH_ARB_sync
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBSyncFuncPointers();

    /**
     *  @brief gets GL_ARB_texture_multisample (part of OpenGL 3.2 core) function pointers, and sets GLEH_ARB_texture_multisample
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBTextureMultisampleFuncPointers();

    /**
     *  @brief gets GL_ARB_vertex_array_bgra (part of OpenGL 3.2 core) function pointers, and sets GLEH_ARB_vertex_array_bgra
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBVertexArrayBGRAFuncPointers();

    /**
     *  @brief gets GL_ARB_shader_bit_encoding (part of OpenGL 3.3 core) function pointers, and sets GLEH_ARB_shader_bit_encoding
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBShaderBitEncodingFuncPointers();

    /**
     *  @brief gets GL_ARB_blend_func_extended (part of OpenGL 3.3 core) function pointers, and sets GLEH_ARB_blend_func_extended
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBBlendFuncExtendedFuncPointers();

    /**
     *  @brief gets GL_ARB_explicit_attrib_location (part of OpenGL 3.3 core) function pointers, and sets GLEH_ARB_explicit_attrib_location
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBExplicitAttribLocationFuncPointers();

    /**
     *  @brief gets GL_ARB_occlusion_query2 (part of OpenGL 3.3 core) function pointers, and sets GLEH_ARB_occlusion_query2
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBOcclusionQuery2FuncPointers();

    /**
     *  @brief gets GL_ARB_sampler_objects (part of OpenGL 3.3 core) function pointers, and sets GLEH_ARB_sampler_objects
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBSamplerObjectsFuncPointers();

    /**
     *  @brief gets GL_ARB_texture_rgb10_a2ui (part of OpenGL 3.3 core) function pointers, and sets GLEH_ARB_texture_rgb10_a2ui
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBTextureRGB10A2uiFuncPointers();

    /**
     *  @brief gets GL_ARB_texture_swizzle (part of OpenGL 3.3 core) function pointers, and sets GLEH_ARB_texture_swizzle
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBTextureSwizzleFuncPointers();

    /**
     *  @brief gets GL_ARB_timer_query (part of OpenGL 3.3 core) function pointers, and sets GLEH_ARB_timer_query
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBTimerQueryFuncPointers();

    /**
     *  @brief gets GL_ARB_instanced_arrays (part of OpenGL 3.3 core) function pointers, and sets GLEH_ARB_instanced_arrays
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBInstancedArraysFuncPointers();

    /**
     *  @brief gets GL_ARB_vertex_type_2_10_10_10_rev (part of OpenGL 3.3 core) function pointers, and sets GLEH_ARB_vertex_type_2_10_10_10_rev
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBVertexType2101010RevFuncPointers();

    /**
     *  @brief gets GL_ARB_texture_query_lod (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_texture_query_lod
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBTextureQueryLodFuncPointers();

    /**
     *  @brief gets GL_ARB_draw_buffers_blend (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_draw_buffers_blend
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBDrawBuffersBlendFuncPointers();

    /**
     *  @brief gets GL_ARB_draw_indirect (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_draw_indirect
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBDrawIndirectFuncPointers();

    /**
     *  @brief gets GL_ARB_gpu_shader5 (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_gpu_shader5
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBGPUShader5FuncPointers();

    /**
     *  @brief gets GL_ARB_gpu_shader_fp64 (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_gpu_shader_fp64
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBGPUShaderFP64FuncPointers();

    /**
     *  @brief gets GL_ARB_sample_shading (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_sample_shading
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBSampleShadingFuncPointers();

    /**
     *  @brief gets GL_ARB_shader_subroutine (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_shader_subroutine
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBShaderSubroutineFuncPointers();

    /**
     *  @brief gets GL_ARB_tessellation_shader (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_tessellation_shader
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBTessellationShaderFuncPointers();

    /**
     *  @brief gets GL_ARB_texture_buffer_object_rgb32 (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_texture_buffer_object_rgb32
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBTextureBufferObjectRGB32FuncPointers();

    /**
     *  @brief gets GL_ARB_texture_cube_map_array (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_texture_cube_map_array
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBTextureCubeMapArrayFuncPointers();

    /**
     *  @brief gets GL_ARB_texture_gather (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_texture_gather
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBTextureGatherFuncPointers();

    /**
     *  @brief gets GL_ARB_transform_feedback2 (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_transform_feedback2
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBTransformFeedback2FuncPointers();

    /**
     *  @brief gets GL_ARB_transform_feedback3 (part of OpenGL 4.0 core) function pointers, and sets GLEH_ARB_transform_feedback3
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBTransformFeedback3FuncPointers();

    /**
     *  @brief gets GL_ARB_ES2_compatibility (part of OpenGL 4.1 core) function pointers, and sets GLEH_ARB_ES2_compatibility
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBES2CompatibilityFuncPointers();

    /**
     *  @brief gets GL_ARB_get_program_binary (part of OpenGL 4.1 core) function pointers, and sets GLEH_ARB_get_program_binary
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBGetProgramBinaryFuncPointers();

    /**
     *  @brief gets GL_ARB_separate_shader_objects (part of OpenGL 4.1 core) function pointers, and sets GLEH_ARB_separate_shader_objects
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBSeparateShaderObjectsFuncPointers();

    /**
     *  @brief gets GL_ARB_shader_precision (part of OpenGL 4.1 core) function pointers, and sets GLEH_ARB_shader_precision
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBShaderPrecisionFuncPointers();

    /**
     *  @brief gets GL_ARB_vertex_attrib_64bit (part of OpenGL 4.1 core) function pointers, and sets GLEH_ARB_vertex_attrib_64bit
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBVertexAttrib64bitFuncPointers();

    /**
     *  @brief gets GL_ARB_viewport_array (part of OpenGL 4.1 core) function pointers, and sets GLEH_ARB_viewport_array
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBViewportArrayFuncPointers();

    /**
     *  @brief gets GL_EXT_draw_buffers2 () function pointers, and sets GLEH_EXT_draw_buffers2
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetEXTDrawBuffers2FuncPointers();

    /**
     *  @brief gets GL_EXT_timer_query () function pointers, and sets GLEH_EXT_timer_query
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetEXTTimerQueryFuncPointers();

    /**
     *  @brief gets GL_EXT_gpu_program_parameters () function pointers, and sets GLEH_EXT_gpu_program_parameters
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetEXTGPUProgramParametersFuncPointers();

    /**
     *  @brief gets GL_EXT_bindable_uniform () function pointers, and sets GLEH_EXT_bindable_uniform
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetEXTBindableUniformFuncPointers();

    /**
     *  @brief gets GL_ARB_shader_texture_lod () function pointers, and sets GLEH_ARB_shader_texture_lod
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBShaderTextureLodFuncPointers();

    /**
     *  @brief gets GL_ARB_texture_buffer_object () function pointers, and sets GLEH_ARB_texture_buffer_object
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBTextureBufferObjectFuncPointers();

    /**
     *  @brief gets GL_S3_s3tc () function pointers, and sets GLEH_S3_s3tc
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetS3S3tcFuncPointers();

    /**
     *  @brief gets GL_EXT_texture_compression_latc () function pointers, and sets GLEH_EXT_texture_compression_latc
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetEXTTextureCompressionLAtcFuncPointers();

    /**
     *  @brief gets GL_EXT_texture_compression_s3tc () function pointers, and sets GLEH_EXT_texture_compression_s3tc
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetEXTTextureCompressionS3tcFuncPointers();

    /**
     *  @brief gets GL_ARB_texture_compression_bptc () function pointers, and sets GLEH_ARB_texture_compression_bptc
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBTextureCompressionBptcFuncPointers();

    /**
     *  @brief gets GL_EXT_texture_filter_anisotropic () function pointers, and sets GLEH_EXT_texture_filter_anisotropic
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetEXTTextureFilterAnisotropicFuncPointers();

    /**
     *  @brief gets GL_EXT_abgr () function pointers, and sets GLEH_EXT_abgr
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetEXTABGRFuncPointers();

    /**
     *  @brief gets GL_ARB_shading_language_include () function pointers, and sets GLEH_ARB_shading_language_include
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBShadingLanguageIncludeFuncPointers();

    /**
     *  @brief gets GL_ARB_cl_event () function pointers, and sets GLEH_ARB_cl_event
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBCLEventFuncPointers();

    /**
     *  @brief gets GL_ARB_debug_output () function pointers, and sets GLEH_ARB_debug_output
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBDebugOutputFuncPointers();

    /**
     *  @brief gets GL_ARB_robustness () function pointers, and sets GLEH_ARB_robustness
     *
     *  @return Returns number of missing functions (zero means success).
     */
    static int n_GetARBRobustnessFuncPointers();

    /**
     *  @brief gets GL_ARB_shader_stencil_export () function pointers, and sets GLEH_ARB_shader_stencil_export
     *
     *  @return Returns number of missing functions (zero means success).
     *
     *  @note this extension has no functions, so this always returns zero.
     */
    static int n_GetARBShaderStencilExportFuncPointers();
